<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Group Workflow Metadata</title>


    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.5.0/font/bootstrap-icons.min.css" crossorigin="anonymous">

    <link href="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/css/fileinput.min.css" media="all" rel="stylesheet" type="text/css" />
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/plugins/piexif.min.js" type="text/javascript"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/plugins/sortable.min.js" type="text/javascript"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/fileinput.min.js"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/locales/LANG.js"></script>
    <link href="../static/styles/upload_file.css" rel="stylesheet">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.form/4.3.0/jquery.form.min.js" integrity="sha384-qlmct0AOBiA2VPZkMY3+2WqkHtIQ9lSdAsAn5RUJD/3vA5MKDgSGcdmIv4ycVxyn" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>


</head>
<body>
    <nav class="navbar navbar-expand-md navbar-light bg-light">
        
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mx-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="/">Home</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('submit_workflow')}}">Submit Workflow</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('workflow_metadata')}}">Workflow Metadata</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('group_workflow_metadata')}}">Group Workflow Metadata</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('inputs')}}">Input Files</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('outputs')}}">Output Files</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('logout')}}"><b>Logout</b></a>
                </li>

            </ul>
        </div>
    </nav>
    <br>
    <div id="accordion">    
        <div class="card">
            <div class="card-header" id="headingFilter">
            <h5 class="mb-0">
                <button class="btn btn-default btn-link" data-toggle="collapse" data-target="#collapseFilter" aria-expanded="true" aria-controls="collapseTwo">
                    Filters
                </button>
            </h5>
            </div>
          
            <div id="collapseFilter" class="collapse show" aria-labelledby="headingFilter" data-parent="#accordion">
        
            <div class="card-body">
                <div class="container">
                    <div class="mb-3">
                        <div class="mb-0">
                            <label for="workflow_type" class="form-label"><b> Workflow Type </b></label>
                            <div class="form-check">
                                <input type="radio" class="form-check-input" id="any_type" name="workflow_type" value="any" checked>Any type
                                <label class="form-check-label" for="any_type"></label>
                              </div>
                              <div class="form-check">
                                <input type="radio" class="form-check-input" id="inab-certh" name="workflow_type" value="inab-certh">inab-certh
                                <label class="form-check-label" for="inab-certh"></label>
                              </div>
                              <div class="form-check">
                                <input type="radio" class="form-check-input" id="somatic-illumina-solid" name="workflow_type" value="somatic-illumina-solid">somatic-illumina-solid
                                <label class="form-check-label" for="somatic-illumina-solid"></label>
                              </div>
                              <div class="form-check">
                                <input type="radio" class="form-check-input" id="somatic-torrent-solid" name="workflow_type" value="somatic-torrent-solid">somatic-torrent-solid
                                <label class="form-check-label" for="somatic-torrent-solid"></label>
                              </div>

                        <div class="mb-3">
                            <label for="status" class="form-label"><b>Status</b></label>
                            <div class="form-check">
                                <input type="radio" class="form-check-input" id="any_status" name="status" value="any" checked>Any status
                                <label class="form-check-label" for="any_status"></label>
                            </div>
                            <div class="form-check">
                                <input type="radio" class="form-check-input" id="succeeded" name="status" value="Succeeded"> Succeeded
                                <label class="form-check-label" for="succeeded"></label>
                            </div>
                            <div class="form-check">
                                <input type="radio" class="form-check-input" id="running" name="status" value="Running">Running
                                <label class="form-check-label" for="running"></label>
                            </div>
                            <div class="form-check">
                                <input type="radio" class="form-check-input" id="failed" name="status" value="Failed">Failed
                                <label class="form-check-label" for="failed"></label>
                            </div>
                        </div>
                        <div class="mb-1">
                            <label for="user" class="form-label"><b> User </b></label>
                            <input type="text" name="user" class="form-control" id="user" aria-describedby="user" placeholder="Any user">
                        </div>
                        <div class="mb-0">
                            <label for="limit" class="form-label"><b> Limit </b></label>
                            <input type="number" name="limit" class="form-control" id="limit" aria-describedby="limit" placeholder="123-456-789">
                        </div> 
                    </div>
                    {% set access_token = data["access_token"] %}
                    <br>
                    <div class="form-center">
                        <button onclick="get_metadata('{{access_token}}');" type="submit" class="btn btn-primary" style="width: 35%" >Get Metadata</button>  
                    </div>
                </div>
            </div>
            </div>
        </div>
    </div>
    <br>
    <br>
    <div class="container">
        <div id="results"></div>
        <div id="alert_wrapper"></div>
    </div>
    


    <script>
    
        function show_metadata(ref_number,user,group,workflow_type,status,submitted_at,finished_at,i) {
        results.innerHTML += `
           
        <div class="card">
            <div class="card-header" id="heading${i}">
                <h5 class="mb-0">
                <button class="btn btn-link" data-toggle="collapse" data-target="#collapse${i}" aria-expanded="true" aria-controls="collapseOne">
                    <b> Referral Number: ${ref_number} | Status: ${status} </b>
                </button>
                </h5>
            </div>
            <div id="collapse${i}" class="collapse" aria-labelledby="heading${i}" data-parent="#results">
                <div class="card-body">
                
                    <div class=container>
                        <table class="table table-bordered">
                            <tbody>
                                <tr>
                                    <td style="text-align:center"><b> Referral Number </b></td>
                                    <td>${ref_number}</td>
                                </tr>
                                <tr>
                                    <td style="text-align:center"> <b> User </b></td>
                                    <td >${user}</td>
                                </tr>
                                <tr>
                                    <td style="text-align:center"><b>Group</b> </td>
                                    <td >${group}</td>
                                </tr>
                                <tr>
                                    <td style="text-align:center"><b> Workflow Type </b></td>
                                    <td >${workflow_type}</td>
                                </tr>
                                <tr>
                                    <td style="text-align:center"><b>Status at</b></td>
                                    <td >${status}</td>
                                </tr
                                <tr>
                                    <td style="text-align:center"><b>Submitted at </b></td>
                                    <td >${submitted_at}</td>
                                </tr>     
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
               
           `               
           
        }
        function show_alert(message, alert) {
      
          alert_wrapper.innerHTML = `
              <div id="alert" class="alert alert-${alert} alert-dismissible fade show" role="alert">
              <span>${message}</span>
              <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
              </button>
              </div>
          `
          }
      
          function get_metadata(access_token){
            var results = document.getElementById("results");
            var alert_wrapper = document.getElementById("alert_wrapper");
            results.innerHTML = ``;
            alert_wrapper.innerHTML = ``;

            var every_type = document.getElementsByName("workflow_type");
            var workflow_type = "any";
            for (let i = 0; i < every_type.length; i++) {
                if(every_type[i]["checked"] == true){
                    workflow_type = every_type[i].value;
                }
                
            }             

            var every_status = document.getElementsByName("status");
            var status = "any";
            for (let i = 0; i < every_status.length; i++) {
                if(every_status[i]["checked"] == true){
                    status = every_status[i].value;
                }
                
            }

            var user_element = document.getElementById("user");
            if(!user_element.value){
                user = "any";
            }else{
                user = user_element.value;
            }

            var limit_element = document.getElementById("limit");
            if(!limit_element.value){
                limit = 0;
            }else{
                limit = limit_element.value;
            }

            var url = "https://rest.workflow-service.dev-greecevscorona.iit.demokritos.gr/group_workflow_metadata";
            var first_arg = true;

            if (workflow_type != "any"){
                url_char = first_arg ? "?" : "&";
                url += (url_char + "workflow_type=" + workflow_type);
                first_arg = false;
            }
            if (status != "any"){
                url_char = first_arg ? "?" : "&";
                url += (url_char + "status=" + status);
                first_arg = false;
            }
            if (user != "any"){
                url_char = first_arg ? "?" : "&";
                url += (url_char + "user=" + user);
                first_arg = false;
            }
            if (limit != 0){
                url_char = first_arg ? "?" : "&";
                url += (url_char + "limit=" + limit);
                first_arg = false;
            }
            var request = new XMLHttpRequest();
            request.open("get", url);
            request.setRequestHeader("Authorization", 'Bearer '+ access_token);
            request.send();


            request.addEventListener("load", function (e) {
                var collapseFilter = document.getElementById("collapseFilter");
                collapseFilter.classList.remove('show');

                if (request.status == 200) {
                    response_text = request.responseText;
                    var response_json = JSON.parse(response_text);
                    
                    var results = response_json["results"];
                    for (let i = 0; i < results.length; i++) {
                        var ref_number = results[i]["referral_num"];
                        var group = results[i]["group"];
                        var status =  results[i]["status"];
                        var submitted_at =  results[i]["submitted_at"];
                        var workflow_type =  results[i]["workflow_type"];
                        var user =  results[i]["user"];
                        var finished_at =  results[i]["finished_at"];

                        show_metadata(ref_number,user,group,workflow_type,status,submitted_at,finished_at,i);

                    }

                    
                }
                else if (request.status == 401){
                    show_alert(`Your session has expired. Please login again` , "danger");
                }
                else if (request.status == 404){
                    show_alert(`No workflows found` , "danger");
                }
                

            });




          }
      
        
      </script>
      







</body>